package com.care.keeper.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.care.common.entity.*;
import com.care.common.service.*;
import com.care.common.util.Result;
import com.care.keeper.service.AbstractKeeperPassportService;
import com.care.keeper.service.KeeperPassportService;
import com.care.keeper.vo.KeeperInfoVO;
import com.care.keeper.vo.OlderVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * 描述：
 *
 * @autho：wenskys
 * @create 2020/5/12 14:13
 **/
@Api(tags = "用户相关接口")
@RestController
@RequestMapping("/keeper/api/member")
public class KeeperMemberApiController {

    @Resource
    private CareSysUserService careSysUserService;

    @Resource
    private KeeperPassportService keeperPassportService;

    @Resource
    private AbstractKeeperPassportService abstractKeeperPassportService;

    @Resource
    private CareStationService careStationService;
    @Resource
    private CareEventOrderChambService careEventOrderChambService;
    @Resource
    private CareDeviceService careDeviceService;
    @Resource
    private CareHouseOlderRelService careHouseOlderRelService;
    @Resource
    private CareOlderService careOlderService;


    @ApiOperation(value = "获取基本信息", notes = "获取用户基本录信息 -- 二期修改")
    @PostMapping("detail/info")
    public Result<Object> detailInfo(@RequestHeader String token) {
        KeeperInfoVO current = keeperPassportService.checkToken(token);
        CareSysUser member = careSysUserService.getById(current.getId());
        BeanUtil.copyProperties(member,current);
        if(current.getStationId() != null) {
            current.setStationName(careStationService.getById(current.getStationId()).getName());
        }
        //服务次数
        QueryWrapper<CareEventOrderChamb> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.lambda().eq(CareEventOrderChamb::getChambId,current.getId()).ne(CareEventOrderChamb::getStatus,"3");
        current.setServeCount(this.careEventOrderChambService.count(queryWrapper2));

        //老人列表
        List<OlderVO> olderVOList = new ArrayList<>();
        QueryWrapper<CareDevice> queryWrapper0 = new QueryWrapper<>();
        queryWrapper0.lambda().eq(CareDevice::getChambId,current.getId());
        List<CareDevice> listDev = this.careDeviceService.list(queryWrapper0);
        if(CollUtil.isNotEmpty(listDev)){
            listDev.forEach(item -> {
                QueryWrapper<CareHouseOlderRel> queryWrapper = new QueryWrapper<>();
                queryWrapper.lambda().eq(CareHouseOlderRel::getHouseId,item.getHouseId());
                List<CareHouseOlderRel> listRel = careHouseOlderRelService.list(queryWrapper);
                if(CollUtil.isNotEmpty(listRel)) {
                    listRel.forEach(i->{
                        CareOlder careOlder = this.careOlderService.getById(i.getOlderId());
                        OlderVO olderVO = new OlderVO();
                        BeanUtil.copyProperties(careOlder,olderVO);
                        olderVOList.add(olderVO);
                    });
                }
            });
        }
        if(CollUtil.isNotEmpty(olderVOList)){
            current.setOlderVOList(olderVOList);
        }

        return Result.success(current);
    }

    @ApiOperation(value = "刷新基本信息", notes = "刷新用户基本录信息")
    @PostMapping("refresh")
    public Result<Object> refreshMember(@RequestHeader String token) {
        KeeperInfoVO lastMemberInfoVO = abstractKeeperPassportService.refreshMember(token);
        return Result.success(lastMemberInfoVO);
    }

   /* @ApiOperation(value = "校验是否要刷新小程序用户信息", notes = "校验是否要刷新小程序用户信息 true刷新")
    @PostMapping("notMatchMemberField")
    public Result<Object> notMatchMemberField(@RequestHeader String token) {
        return Result.success(passportService.notMatchMemberField(token));
    }
*/

}
